{ lib, stdenv, fetchgit, nim, nimblePackages }:

stdenv.mkDerivation rec {
  pname = "device_manager";
  version = "0.0";
  outputs = [ "out" "dhall" ];

  src = fetchgit {
    url = "https://git.sr.ht/~ehmry/${pname}";
    rev = "018ec1ccb109b275a54462d85eb006bc51ea04ac";
    sha256 = "1aiygypkjh2r397xwzpccav4mmkdhx7mc580javsm4cr3hhkhbvj";
  };

  nimFlags = with nimblePackages;
    map (lib: "--path:${lib}/src") [ genode ] ++ [ "-d:posix" ];

  nativeBuildInputs = [ nim ];

  preHook = ''
    export HOME="$NIX_BUILD_TOP"
  '';

  buildPhase = ''
    runHook preBuild
    nim cpp $nimFlags src/$pname
    runHook postBuild
  '';

  installPhase = ''
    install -Dt $out/bin src/$pname
    install -Dt $dhall config/package.dhall
  '';
}
