{
  name = "graphics";
  machine = { config, lib, pkgs, ... }: {

    genode.gui.consoleLog.enable = true;

    genode.core.storeBackend = "fs";
    hardware.genode.framebuffer.driver = "boot";
    hardware.genode.usb = {
      enable = true;
      biosHandoff = false;
      storage.enable = true;
    };

    genode.init.verbose = true;
    genode.init.children.hello = {
      package = pkgs.hello;
      configFile = ./hello.dhall;
    };

  };
  testScript = ''
    start_all()
    machine.wait_until_serial_output("child \"init\" exited with exit value 0")
  '';
}
